
#include <proto/exec.h>
#include <proto/datatypes.h>
#include <datatypes/pictureclass.h>
#include <string.h>

struct BitMap *copy_bitmap (struct BitMap *oldbm);

BOOL load_pic (char *filename,struct BitMap **bitmap_ptr,ULONG **palette_ptr)

{
Object *o;
long ncols = 0;
struct BitMap *bitmap;
ULONG *palette;

o = NewDTObject (filename,
	DTA_GroupID,GID_PICTURE,
	PDTA_Remap,FALSE,
	TAG_END);
if (!o)
	return (FALSE);

DoDTMethod (o,NULL,NULL,DTM_PROCLAYOUT,NULL,TRUE);

GetDTAttrs (o,
	PDTA_NumColors,&ncols,
	PDTA_CRegs,&palette,
	PDTA_DestBitMap,&bitmap,
	TAG_END);

if (ncols)
	{
	long size = ncols * 3 * sizeof(ULONG);
	*palette_ptr = AllocVec (size,0);
	if (*palette_ptr)
		memcpy (*palette_ptr,palette,size);
	}

*bitmap_ptr = copy_bitmap (bitmap);

DisposeDTObject (o);

return (TRUE);
}
